import { ITypedEvent } from "../../TypedEvent";
import { FieldChangeResult } from "../FieldChangeResult";
import { IDeviceTaskTypeInfo, IDeviceResponseTypeInfo, IDevice } from './IDevice';
import { ChannelConfigurations, IDeviceChannel, TaskExecution } from "./IDeviceChannel";
import { IDeviceState, IDeviceStateData } from "./IDeviceState";
import { IDeviceTask } from "./IDeviceTask";
import { DeviceTaskExecutionResult } from "./TaskExecutionResult";
export declare class DeviceChannel implements IDeviceChannel {
    private _device;
    private _number;
    private _name;
    private _iconName;
    private _states;
    private _mode;
    private _channelGroups;
    private _isHidden;
    private _availableTasksTypes;
    private _availableResponseTypes;
    private _onTasksExecutionChangedEvent;
    SetDevice(device: IDevice): void;
    GetChannelConfigurationData(): ChannelConfigurationData;
    HideAsync(): Promise<FieldChangeResult>;
    ShowAsync(): Promise<FieldChangeResult>;
    ChangeNameAsync(name: string): Promise<FieldChangeResult>;
    ChangeIconNameAsync(name: string): Promise<FieldChangeResult>;
    ChangeGroupsAsync(groups: string[]): Promise<FieldChangeResult>;
    ChangeConfigurationAsync(configuration: ChannelConfigurationData): Promise<FieldChangeResult>;
    get Number(): number;
    set Number(value: number);
    get Name(): string;
    set Name(value: string);
    get IconName(): string;
    set IconName(value: string);
    get States(): IDeviceState<IDeviceStateData>[];
    set States(value: IDeviceState<IDeviceStateData>[]);
    set State(value: IDeviceState<IDeviceStateData>);
    get Mode(): ChannelConfigurations;
    set Mode(value: ChannelConfigurations);
    get ChannelGroups(): string[];
    set ChannelGroups(value: string[]);
    get IsHidden(): boolean;
    set IsHidden(value: boolean);
    get AvailableTaskTypes(): IDeviceTaskTypeInfo[];
    set AvailableTaskTypes(value: IDeviceTaskTypeInfo[]);
    get AvailableResponseTypes(): IDeviceResponseTypeInfo[];
    set AvailableResponseTypes(value: IDeviceResponseTypeInfo[]);
    OnTasksExecutionChangeEvent(): ITypedEvent<TaskExecution>;
    ExecuteTaskAsync(task: IDeviceTask): Promise<DeviceTaskExecutionResult>;
}
export declare class ChannelConfigurationData {
    Channel: number;
    ChannelName: string;
    Configuration: ChannelConfigurations;
    GroupsGuids: string[];
    IconName: string;
    Hidden: boolean;
}
