var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { nameof } from 'ts-simple-nameof';
import { Api } from '../../Api';
import { ExalusConnectionService } from '../ExalusConnectionService';
import { DataFrame, Method, Status } from '../../DataFrame';
import { User } from './User';
import { DependencyContainer } from '../../DependencyContainer';
export class UsersService {
    constructor() {
        this._connection = null;
        this._serviceName = nameof(UsersService);
        this._connection = Api.Get(ExalusConnectionService);
    }
    GetServiceName() {
        return this._serviceName;
    }
    GetUsersAsync() {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield ((_a = this._connection) === null || _a === void 0 ? void 0 : _a.SendAndWaitForResponseAsync(new GetUsersListRequest(), 5000, false));
            if (result === null || result === undefined)
                return Promise.resolve([]);
            if ((result === null || result === void 0 ? void 0 : result.Status) == Status.OK) {
                if (result.Data != null) {
                    const users = [];
                    result.Data.forEach(element => {
                        var user = new User();
                        user.AccessLevel = element.AccessLevel;
                        user.Email = element.Email;
                        user.Gender = element.Gender;
                        user.Guid = element.Guid;
                        user.IsAccountOnline = element.IsAccountOnline;
                        user.Name = element.Name;
                        user.IsActive = element.IsActive;
                        user.IsBanned = element.IsBanned;
                        user.Phone = element.Phone;
                        user.Surname = element.Surname;
                        users.push(user);
                    });
                    return users;
                }
                else
                    return Promise.resolve([]);
            }
            else if ((result === null || result === void 0 ? void 0 : result.Status) == Status.NoData)
                return Promise.resolve([]);
            else {
                (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Debug(UsersService, `Failed to retrieve users, error: ${result.Status}`);
                throw new Error(`Failed to retrieve users, error: ${result.Status}`);
            }
            return Promise.resolve([]);
        });
    }
    GetUserAsync(id) {
        return new Promise((resolve, reject) => {
            resolve(null);
        });
    }
    CreateUserAsync(user) {
        return new Promise((resolve, reject) => {
            resolve(user);
        });
    }
    UpdateUserAsync(user) {
        return new Promise((resolve, reject) => {
            resolve(user);
        });
    }
    DeleteUserAsync(id) {
        return new Promise((resolve, reject) => {
            resolve();
        });
    }
}
class GetUsersListRequest extends DataFrame {
    constructor() {
        super();
        this.Resource = "/users/list";
        this.Method = Method.Get;
    }
}
//# sourceMappingURL=UsersService.js.map