import { Api } from '../../Api';
import { LocalStorageService } from '../LocalStorageService';
import { nameof } from 'ts-simple-nameof';
import { LoggerService } from '../Logging/LoggerService';
export class WebApiCacheService {
    constructor() {
        this._log = Api.Get(LoggerService);
        this._serviceName = nameof(WebApiCacheService);
        WebApiCacheService._localStorageService = Api.Get(LocalStorageService);
    }
    GetServiceName() {
        return this._serviceName;
    }
    GetResourceName(data) {
        return `${data.Resource}_${data.Method}`;
    }
    Cache(data) {
        var _a;
        let tmp = JSON.stringify(data);
        this._log.Debug(`Caching request: ${data.Resource} ${data.Method}`);
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Save(WebApiCacheService, this.GetResourceName(data), tmp);
    }
    GetCache(data) {
        var _a;
        let tmp = (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Read(WebApiCacheService, this.GetResourceName(data));
        if (tmp != null)
            this._log.Debug(`Got request response from cache: ${data.Resource} ${data.Method}`);
        return tmp;
    }
    ClearCache() {
        var _a;
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.DropStorage(WebApiCacheService);
        this._log.Debug(`Clearing cache for ${this.GetServiceName()}`);
    }
    Remove(data) {
        var _a;
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Remove(WebApiCacheService, this.GetResourceName(data));
        this._log.Debug(`Clearing cache for cache: ${data.Resource} ${data.Method}`);
    }
}
WebApiCacheService._localStorageService = null;
//# sourceMappingURL=WebApiCacheService.js.map